/*
 * dSS11 led handling daemon
 * Copyright (c) 2011 aizo ag, Switzerland
 *
 * Author: Johannes Winkelmann <johannes.winkelmann@aizo.com>
 *         Michael Tross <michael.tross@aizo.com>
 */

#ifndef COMMANDHANDLER_H_
#define COMMANDHANDLER_H_

#include <stdint.h>
#include <vector>
#include <string>
#include <pthread.h>

#include "ledd_common.h"

class LedFactory;
class Sequence;

class CommandHandler
{
public:
  CommandHandler(LedFactory* ledFactory);
  ~CommandHandler();
  // callback
  static void handlerCallback(const ledd_actions command, void *arg);
  void handle(const ledd_actions command);

  enum States { eSTATE_READY, eSTATE_FAILURE, eSTATE_STARTUP, eSTATE_UPDATE, eSTATE_RAINBOW };
  bool updateLeds();

private:
  void stopSequence();

  LedFactory* m_ledFactory;
  Sequence* m_sequence;

  States m_state;
  States m_oldState;

  bool m_ds485Ok;
  bool m_info2Ok;
  bool m_info3Ok;

  bool m_netOk;
  bool m_wifiOk;
  bool m_internetOk;

  bool m_hardwareErr;
  bool m_softwareErr;
  bool m_err2Err;

  pthread_t m_thread;
};

#endif /* COMMANDHANDLER_H_ */
