/*
 * dSS11 led handling daemon
 * Copyright (c) 2011 aizo ag, Switzerland
 *
 * Author: Johannes Winkelmann <johannes.winkelmann@aizo.com>
 */

#ifndef LED_H_
#define LED_H_

#include <stdint.h>
#include <string>

class LED
{
public:
  LED(uint8_t state);
  virtual ~LED() {}
  void call();

private:
  virtual void turnOn() = 0;
  virtual void turnOff() = 0;

  uint8_t m_state;
};

class LedFactory
{
public:
  virtual ~LedFactory() {}
  virtual LED* createLED(const std::string& name, uint8_t state) = 0;
};


#endif /* LED_H_ */
