/*
    Copyright (c) 2012 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@mediatomb.cc> 

    This file is part of dss11-ledd.

    dss11-ledd is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dss11-ledd is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with dss11-ledd. If not, see <http://www.gnu.org/licenses/>.
*/

#include "config.h"

#include <string.h>
#include "ledd_common.h"

const char *ledd_action_to_string(ledd_actions action)
{
    const char *ret = "unhandled";

    switch (action)
    {
        case ledd_ready:
            ret = "ready";
            break;
        case ledd_failure:
            ret = "failure";
            break;
        case ledd_system_update_started:
            ret = "system_update_started";
            break;
        case ledd_system_update_completed:
            ret = "system_update_completed";
            break;
        case ledd_rainbow:
            ret = "rainbow";
            break;
        case ledd_rainbow_completed:
            ret = "rainbow_completed";
            break;
        case ledd_ds485_ok:
            ret = "ds485_ok";
            break;
        case ledd_ds485_err:
            ret = "ds485_err";
            break;
        case ledd_info2_ok:
            ret = "info2_ok";
            break;
        case ledd_info2_err:
            ret = "info2_err";
            break;
        case ledd_info3_ok:
            ret = "info3_ok";
            break;
        case ledd_info3_err:
            ret = "info3_err";
            break;
        case ledd_net_ok:
            ret = "net_ok";
            break;
        case ledd_net_err:
            ret = "net_err";
            break;
        case ledd_wifi_ok:
            ret = "wifi_ok";
            break;
        case ledd_wifi_err:
            ret = "wifi_err";
            break;
        case ledd_internet_ok:
            ret = "internet_ok";
            break;
        case ledd_internet_err:
            ret = "internet_err";
            break;
        case ledd_hw_ok:
            ret = "hw_ok";
            break;
        case ledd_hw_err:
            ret = "hw_err";
            break;  
        case ledd_sw_ok:
            ret = "sw_ok";
            break;
        case ledd_sw_err:
            ret = "sw_err";
            break;
        case ledd_err2_ok:
            ret = "err2_ok";
            break;
        case ledd_err2_err:
            ret = "err2_err";
            break;
        case ledd_unhandled:
        default:
            ret = "unhandled";
            break;
    }

    return ret;
}

ledd_actions ledd_string_to_action(const char *action)
{
    if (strcmp(action, "ready") == 0)
    {
        return ledd_ready;
    }
    else if (strcmp(action, "failure") == 0)
    {
        return ledd_failure;
    }
    else if (strcmp(action, "system_update_started") == 0)
    {
        return ledd_system_update_started;
    }
    else if (strcmp(action, "system_update_completed") == 0)
    {
        return ledd_system_update_completed;
    }
    else if (strcmp(action, "rainbow") == 0)
    {
        return ledd_rainbow;
    }
    else if (strcmp(action, "rainbow_completed") == 0)
    {
        return ledd_rainbow_completed;
    }
    else if (strcmp(action, "ds485_ok") == 0)
    {
        return ledd_ds485_ok;
    }
    else if (strcmp(action, "ds485_err") == 0)
    {
        return ledd_ds485_err;
    }
    else if (strcmp(action, "info2_ok") == 0)
    {
        return ledd_info2_ok;
    }
    else if (strcmp(action, "info2_err") == 0)
    {
        return ledd_info2_err;
    }
    else if (strcmp(action, "info3_ok") == 0)
    {
        return ledd_info3_ok;
    }
    else if (strcmp(action, "info3_err") == 0)
    {
        return ledd_info3_err;
    }
    else if (strcmp(action, "net_ok") == 0)
    {
        return ledd_net_ok;
    }
    else if (strcmp(action, "net_err") == 0)
    {
        return ledd_net_err;
    }
    else if (strcmp(action, "wifi_ok") == 0)
    {
        return ledd_wifi_ok;
    }
    else if (strcmp(action, "wifi_err") == 0)
    {
        return ledd_wifi_err;
    }
    else if (strcmp(action, "internet_ok") == 0)
    {
        return ledd_internet_ok;
    }
    else if (strcmp(action, "internet_err") == 0)
    {
        return ledd_internet_err;
    }
    else if (strcmp(action, "hw_ok") == 0)
    {
        return ledd_hw_ok;
    }
    else if (strcmp(action, "hw_err") == 0)
    {
        return ledd_hw_err;
    }
    else if (strcmp(action, "sw_ok") == 0)
    {
        return ledd_sw_ok;
    }
    else if (strcmp(action, "sw_err") == 0)
    {
        return ledd_sw_err;
    }
    else if (strcmp(action, "err2_ok") == 0)
    {
        return ledd_err2_ok;
    }
    else if (strcmp(action, "err2_err") == 0)
    {
        return ledd_err2_err;
    }

    return ledd_unhandled;
}

