/*
 * dSS11 led handling daemon
 * Copyright (c) 2011 aizo ag, Switzerland
 *
 * Author: Johannes Winkelmann <johannes.winkelmann@aizo.com>
 */

#include "ledgroup.h"
#include "led.h"

LedGroup::~LedGroup()
{
  std::vector<LED*>::iterator it = m_leds.begin();
  for (; it != m_leds.end(); ++it) {
    delete *it;
  }
}

void LedGroup::addLed(LED* led)
{
  m_leds.push_back(led);
}

void LedGroup::activate()
{
  std::vector<LED*>::iterator it = m_leds.begin();
  for (; it != m_leds.end(); ++it) {
    (*it)->call();
  }
}

