/*
 * dSS11 led handling daemon
 * Copyright (c) 2012 aizo ag, Switzerland
 *
 * Author: Michael Tross <michael.tross@aizo.com>
 */

#include <stdio.h>
#include <ctype.h>
#include <stdint.h>
#include <pthread.h>
#include <syslog.h>
#include <sys/time.h>
#include <string.h>
#include <stdarg.h>

#include "report.h"

extern int debugLevel;


double timestamp(void)
{
  struct timeval tv;

  gettimeofday(&tv, NULL);
  return (tv.tv_sec + tv.tv_usec*1e-6);
}

void report(int errlevel, const char *fmt, ... )
{
  if (errlevel <= debugLevel) {
    char buf[BUFSIZ];
    va_list ap;
    //pthread_mutex_lock(&reportMutex);

    strncpy(buf, "ledd: ", BUFSIZ);
    va_start(ap, fmt) ;
    vsnprintf(buf + strlen(buf), sizeof(buf)-strlen(buf), fmt, ap);
    va_end(ap);

    if (0 /*inBackground*/) {
      syslog(errlevel, "%s", buf);
    }
    else {
      char buf2[BUFSIZ], *sp, tsbuf[30];
      struct timeval t;
      gettimeofday(&t, NULL);
      strftime(tsbuf, sizeof(tsbuf), "%Y-%m-%d %H:%M:%S", localtime(&t.tv_sec));
      (void)snprintf(buf2, BUFSIZ, "[%s.%03d] ", tsbuf, (int)t.tv_usec / 1000);
      for (sp = buf; *sp != '\0'; sp++)
    	if (isprint(*sp) || (isspace(*sp) && (sp[1]=='\0' || sp[2]=='\0')))
    	  (void)snprintf(buf2+strlen(buf2), 2, "%c", *sp);
    	else
    	  (void)snprintf(buf2+strlen(buf2), 6, "\\x%02x", (unsigned)*sp);
		  (void)fputs(buf2, stderr);
	}

    //pthread_mutex_unlock(&reportMutex);
  }
}
